/*
 *        Name: GOPSRVYS REXX
 *              Gopher Server Search Engine utilizing WISHLP
 *              Original by Yossie Silverman <YOSSIE@UCSFVM>
 *
 *   To create a search item do the following:
 *
 *     1) Create a standard gopher FILELIST of all files to be
 *        searched.  (Only ' fn ft fm title' will work, fm can
 *        (and should) be *
 *     2) GOPGEN INDEX menu
 *     3) Put the name and title of the searched menu
 *        in the menu you want to access it from (parent)
 *     4) Mark the searched menu as Type 7 either
 *        with a NAMES file or in the parent menu.
 */

Parse Arg search                            /* retrieve search string */

'PEEKTO'            /*  sync with input  */

Address "COMMAND" 'GLOBALV SELECT GOPHERD GET MENU FM'
'CALLPIPE COMMAND LISTFILE' menu 'GOPINDEX * (NOHEADER' ,
        '| VAR FILESPEC'
If rc ^= 0 Then Exit rc
Parse Var filespec . . fm .
Say "GOPSRVYS: MENU =" menu '-' fm
'CALLPIPE COMMAND WISHLP' menu 'GOPINDEX' fm search ,
        '| SPEC /      / 1 1-* NEXT | *:'

Exit rc

