/********************************************************************
 * lindner
 * 3.3
 * 1993/04/15 21:28:27
 * /home/mudhoney/GopherSrc/CVS/gopher+/gopher/globals.h,v
 * Exp
 *
 * Paul Lindner, University of Minnesota CIS.
 *
 * Copyright 1991, 1992 by the Regents of the University of Minnesota
 * see the file "Copyright" in the distribution for conditions of use.
 *********************************************************************
 * MODULE: globals.h
 * Global variables and #defines
 *********************************************************************
 * Revision History:
 * globals.h,v
 * Revision 3.3  1993/04/15  21:28:27  lindner
 * Mods for remote access
 *
 * Revision 3.2  1993/03/24  16:57:51  lindner
 * New version#
 *
 * Revision 3.1.1.1  1993/02/11  18:02:57  lindner
 * Gopher+1.2beta release
 *
 * Revision 1.5  1993/02/09  22:09:28  lindner
 * Added more fcns and upped version #
 *
 * Revision 1.4  1993/01/21  03:29:48  lindner
 * Updated version number for 1.12
 *
 * Revision 1.3  1993/01/08  19:44:21  lindner
 * Updated version number
 *
 * Revision 1.2  1992/12/31  04:04:51  lindner
 * Changes for VMS
 *
 * Revision 1.1  1992/12/10  23:32:16  lindner
 * gopher 1.1 release
 *
 *********************************************************************/

#define MAXRESP      9                  /* Max size of a response list*/
#define WHOLELINE 80                   /* Used in ourutil.c */

/*
 * These are some funky defines that assures that global variables are
 * declared only once.  (when globals.c includes this file with EXTERN
 * defined.
 */

#ifndef EXTERN
#define EXTERN extern
#define INIT(x)
#else
#define EXTERN
#define INIT(x) =(x)
#endif

/*
 * We keep the version line stored here for easy access
 */
EXTERN char    *VERSIONline INIT("Internet Gopher+ Information Client v1.2beta3");

/*** Global variables ***/

EXTERN RCobj     *GlobalRC;

EXTERN String    *PrinterCommand; /*used for configuration options */
EXTERN String    *PagerCommand;   
EXTERN String    *TelnetCommand;  
EXTERN String    *MailCommand;
EXTERN String    *PlayCommand;
EXTERN String    *EditorCommand;
EXTERN String    *TN3270Command;
EXTERN String    *MIMECommand;
EXTERN String    *ImageCommand;

EXTERN boolean   ChangedDefs INIT(FALSE);

EXTERN char      *Searchstring INIT(NULL);
EXTERN int       iLevel INIT(0);
EXTERN BOOLEAN   SecureMode INIT(FALSE);
EXTERN BOOLEAN	 NoShellMode INIT(FALSE);
EXTERN BOOLEAN   DEBUG INIT(FALSE);
#ifdef REMOTEUSER
EXTERN BOOLEAN   RemoteUser INIT(FALSE);
#endif

EXTERN GopherDirObj *CurrentDir INIT(NULL);
EXTERN GopherDirObj *OldDirs[30];  /** Should be a stack... **/

EXTERN GopherDirObj *BookmarkDir INIT(NULL);

EXTERN char      USERCAP[WHOLELINE];    /* The validated user capability */
EXTERN int       SOUNDCHILD INIT(0);     /* The pid of the sound player child. */
EXTERN CursesObj *CursesScreen;

EXTERN char *Gopenfile INIT(NULL);

#ifndef VMS
extern int errno;
#endif

/*** Externals ***/

#ifndef VMS
extern char **environ;                  /* User environment array */
extern char *sys_errlist[];
#endif

/*** Prototypes and forward declarations ***/

/*** Ourutils.c ***/
void display_file(/* char *Filename */);
void ZapCRLF( /* char *buffer */ );
int  outchar( /*char c*/ );        
void CursesErrorMsg( /* char* */);
void GetOneOption(/* char*, char* */);

int  process_request(/* ZeGopher*/);
int  Load_Dir(/*ZeGopher*/);
int  Load_Index();
int  Load_Index_or_Dir();
void GetOneOption(/* */);
void check_sock(/* int, char* */);
char *Choose_View(/* gs */);
char **AskBlock(/* gs */);

