/********************************************************************
 * lindner
 * 3.6
 * 1993/04/15 21:27:26
 * /home/mudhoney/GopherSrc/CVS/gopher+/gopher/ourutils.c,v
 * Exp
 *
 * Paul Lindner, University of Minnesota CIS.
 *
 * Copyright 1991, 1992,1993 by the Regents of the University of Minnesota
 * see the file "Copyright" in the distribution for conditions of use.
 *********************************************************************
 * MODULE: ourutils.c
 * stuff that doesn't really fit anywhere else.
 *********************************************************************
 * Revision History:
 * ourutils.c,v
 * Revision 3.6  1993/04/15  21:27:26  lindner
 * NOMAIL option, Remote user stuff, and bug in Ask
 *
 * Revision 3.5  1993/03/26  19:44:36  lindner
 * Fix for CSO stuff and saving binary files
 *
 * Revision 3.4  1993/03/24  17:01:27  lindner
 * Major changes to the way things are displayed/saved
 *
 * Revision 3.3  1993/03/18  23:32:41  lindner
 * Added Note: support and default values to AskBlock
 *
 * Revision 3.2  1993/02/19  21:12:16  lindner
 * Generalized on gopher+ stuff, strip long filenames to reasonable length
 *
 * Revision 3.1.1.1  1993/02/11  18:02:58  lindner
 * Gopher+1.2beta release
 *
 * Revision 2.1  1993/02/09  22:37:50  lindner
 * Much new in the way of display routines.
 *
 * Revision 1.11  1993/01/31  00:10:44  lindner
 * Checks for multiple views when saving.
 *
 * Revision 1.10  1993/01/17  04:30:38  lindner
 * VMSfile() truncates to a legal VMS filename length.
 *
 * Revision 1.9  1993/01/14  21:16:58  lindner
 * New routines to make nice filenames for Unix and VMS.
 * Add return to make screen look nice for VMS pagers.
 *
 * Revision 1.8  1993/01/12  21:45:17  lindner
 * Removed \n from system() calls.
 * Added filter to Save_file for directories and searches
 *
 * Revision 1.7  1993/01/12  18:19:32  lindner
 * Fixed Save_file call in display_file
 *
 * Revision 1.6  1993/01/09  01:37:32  lindner
 * Changed Save_file so that it takes a default filename.
 * Removed some dead code...
 *
 * Revision 1.5  1992/12/31  05:50:03  lindner
 * Added mods for VMS
 *
 * Revision 1.4  1992/12/11  21:19:51  lindner
 * Really fixed RealName this time..  Gotta test these things..
 *
 * Revision 1.3  1992/12/11  20:59:48  lindner
 * Fixed problem with syntax error RealName, grrr
 *
 * Revision 1.2  1992/12/11  20:54:38  lindner
 * Mailing items with quotes in their name now works, added fflush(stdin)
 * everywhere to fix some input processing problems.
 *
 * Revision 1.1  1992/12/10  23:32:16  lindner
 * gopher 1.1 release
 *
 *********************************************************************/


#include "gopher.h"
#ifndef VMS
#include <pwd.h>
#endif
#ifdef mips
char *getenv();
#endif

extern int twirl();

int 
outchar(c)
  char c;
{
        /** output the given character.  From tputs... **/
        /** Note: this CANNOT be a macro!              **/

        putc(c, stdout);
	return(c);
}


/*
 * Function that twirls on the screen..
 *
 * pct is an optional val that is to be displayed.
 */

int
twirl(pct)
  int pct;
{
     static int twirlnum = 0;
     static char *twirls = "-/|\\";

     addch('\b');
     addch(*(twirls + (twirlnum++ % 4 )));
     refresh();

     return(0);
}



/*
** This procedure sends a file through the mail.
*/

void
mail_file(Filename, Realname)
  char *Filename, *Realname;
{
     static char *SaveName = NULL;
     char command[512];
     
     if (SaveName==NULL) {
	  if ((SaveName = (char *) malloc(sizeof(char)*256)) == NULL)
	       perror("Out of memory!");
	  *SaveName = '\0';
     }

     if (CURGetOneOption(CursesScreen, "Mail current document to:", SaveName)<0)
	  return;
     
     if (*SaveName == '\0')
	  return;
     
#define ACHARS "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789%.@!-_"
		    
     if (SecureMode)
	  if ( strspn(SaveName, ACHARS) != strlen(SaveName)) {
	       puts(CURgetBell(CursesScreen));
	       fflush(stdout);
	       Draw_Status("Address syntax rejected...");
	       refresh();
	       return;
	  }

     if (strchr(Realname, '\"') != NULL)
	  Realname = "Gopher File";
     
     Draw_Status("Mailing File...");
     refresh();
     
#ifdef VMS
     sprintf(command, "%s/subject=\"%s\" %s %s", 
           MAIL_COMMAND, Realname, Filename, SaveName);
#else
     sprintf(command, "%s -s \"%s\" %s < %s", 
	     MAIL_COMMAND, Realname, SaveName, Filename);
#endif
     system(command);

}

/*
 *  This fcn allows one to choose a view out of a potential nine views.
 */

char *
Choose_View(gs)
  GopherObj *gs;
{
     int viewno;
     static char viewnlang[64];
     char *view;

     if (GSisGplus(gs)) {
	  char *choices[10];

	  GSgetginfo(gs);
	  
	  if (GSgetNumViews(gs) >1) {
	       int choice;

	       for (viewno=0; viewno <GSgetNumViews(gs); viewno++) {
		    choices[viewno] = strdup(VIgetViewnLang(GSgetView(gs,viewno),viewnlang));
	       }

	       choices[viewno] = NULL;
	       choice = CURChoice(CursesScreen, GSgetTitle(gs), choices,
				  "Choose a document type");
	       if (choice == -1)
		    return(NULL);

	       strcpy(viewnlang, choices[choice]);
	       
	       for (viewno = 0; viewno <GSgetNumViews(gs); viewno++) 
		    free(choices[viewno]);

	       return(viewnlang);
	  }
	  else if (GSgetNumViews(gs) == 1)
	       return(VIgetViewnLang(GSgetView(gs, 0), viewnlang));
	  else
	       return("");
     }
     else {
	  switch (GSgetType(gs)) {
	  case A_FILE:
	  case A_CSO:
	       view = "Text";
	       break;
	  case A_GIF:
	       view = "image/gif";
	       break;
	  case A_IMAGE:
	       view = "image";
	       break;
	  case A_SOUND:
	       view = "audio/mulaw";
	       break;
	  case A_TN3270:
	       view = "terminal/tn3270";
	       break;
	  case A_TELNET:
	       view = "terminal/telnet";
	       break;
	  case A_UNIXBIN:
	  case A_PCBIN:
	  case A_MACHEX:
	       view = "Binary";
	       break;
	  }
	  return(view);
     }
}

/*
 * Crude implementation of the ASK block stuff.
 */

char **
AskBlock(gs)
  GopherObj *gs;
{
     int Asknum;
     char *choices[20];
     Blockobj *bl;
     static char *responses[20];
     char askline[256];
     char *defaultval;
     int i,j;

     GSgetginfo(gs);
	  
     bl = GSfindBlock(gs, "ASK");

     if (bl == NULL)
	  return(NULL);

     for (Asknum=0; Asknum <BLgetNumLines(bl); Asknum++) {
	  char *askprompt, *cp;

	  strcpy(askline, BLgetLine(bl, Asknum));
	  /*** find the type of question ***/
	  askprompt = strchr(askline, ':');
	  if (askprompt == NULL) {
	       continue;
	  }

	  askprompt+=2;
	  
	  /*** Zap the tabs, and load it up.. ***/
	  cp = strchr(askprompt, '\t');
	  if (cp != NULL) {
	       defaultval = cp+1;
	       *cp = '\0';
	  } else
	       defaultval = NULL;


	  choices[Asknum] = strdup(askprompt);
	  if (strncasecmp(askline, "Note:", 5) == 0)
	       responses[Asknum] = NULL;
	  else {
	       responses[Asknum] = (char *) malloc(40);
	       responses[Asknum][0] = '\0';
	       if (defaultval != NULL)
		    strncpy(responses[Asknum], defaultval, 39);
	  }
     }
     
     choices[Asknum] = NULL;
     responses[Asknum] = NULL;
     
     if (CURRequest(CursesScreen, GSgetTitle(gs), choices, responses))
	  return(NULL);
     else {
	  /*** Free memory ***/
	  for (i=Asknum; i >= 0; i--) {
	       if (choices[i] != NULL) free(choices[i]);

	       /** Okay, eliminate Note: entries block stuff **/
	       if (responses[i] == NULL) {
		    for (j=i; j<Asknum; j++) {
			 responses[j] = responses[j+1];
		    }
	       }
	  }
	  return(responses);
     }
}

/*
 * Handle a gplus error
 */

void
Gplus_Error(sockfd)
  int sockfd;
{
     char inputline[256];
     char *errmsg[25];
     int i;
     
     if (DEBUG) fprintf(stderr,"Gplus_Error...");
     for (i=0; ;i++) {
	  char *cp;

	  if (readline(sockfd, inputline, sizeof(inputline)) <=0)
	       break;
	  ZapCRLF(inputline);
	  if (strcmp(inputline, ".")==0)
	       break;
	  
	  cp = inputline;
	  while ((cp = strchr(cp, '\t')) != NULL)
	       *cp = ' ';

	  errmsg[i] = strdup(inputline);
     }
     
     errmsg[i] = NULL;
     
     CURDialog(CursesScreen, "Gopher Transmission Error", errmsg);
     for (i=0; ; i++) {
	  if (errmsg[i] == NULL)
	       break;
	  else
	       free(errmsg[i]);
     }

}



/* Read from socket fd to file f until EOF */
boolean
CopyFile(fd, f)
  int fd;
  FILE *f;
{
     int numread;
     char buf[1024];

	       
     while ((numread = readn(fd, buf, sizeof buf)) > 0) {
	  if (fwrite(buf, numread, 1, f) == 0) {
	       closenet(fd);
	       return(FALSE);
	  }
     }
}


/*
 * This fcn transfers a file from a gopher server into f.
 *
 */

boolean
GStoFile(gs, f, view, askdata, twirlfn)
  GopherObj *gs;
  FILE *f;
  char *view;
  char **askdata;
  int (*twirlfn)();
{
     int numread, sockfd;
     boolean success = TRUE;
     char buf[1024];
     int viewno, bytemethod;
     int line = 0, i;

     /*** Check for gopher+ and multiple views ***/

     if (DEBUG) fprintf(stderr,"GStoFile");
     if ((sockfd = GSconnect(gs)) <0) {
	  check_sock(sockfd, GSgetHost(gs), GSgetPort(gs));
	  return(FALSE);
     }

     /** Send out the request **/
     GStransmit(gs, sockfd, NULL, "+", view, askdata);
     bytemethod = GSrecvHeader(gs, sockfd);

     if (bytemethod == 0) {
	  Gplus_Error(sockfd);
	  
	  return(FALSE);
     }
	  

     Draw_Status("Receiving file...");
     refresh();
     

     if (GSisText(gs, view)) {
	  while (readline(sockfd, buf, sizeof(buf)) > 0) {
	       ZapCRLF(buf);
	       line ++;
	       if (*buf == '.' && *(buf+1) == '\0')
		    break;



	       if (GSgetType(gs) == A_CSO) {
		    if (*buf == '2')
			 break;
		    
		    if ((*buf >= '3') && (*buf <= '9'))  {
			 fprintf(f, "%s\n", GSgetPath(gs));
			 fprintf(f, "%s\n", buf+4);
			 break;
		    }
		    if (*buf == '-') {


			 if (buf[1] >= '3' && buf[1] <= '9') {
			      fprintf(f, "%s\n", GSgetPath(gs));
			      fprintf(f, "%s\n", buf+5);
			 }
			 else {
			      char *colonpos = strchr(buf+5,':');
			      if (colonpos != NULL && *(colonpos-1) != i) {
				   fprintf(f, "-------------------------------------------------------\n");
				   i = *(colonpos-1);
			      }
			      fputs((colonpos ? colonpos+1 : buf+6), f);
			      fputc('\n', f);
			 }
		    }
	       }
	       else {
		    fputs(buf, f);
		    putc('\n', f);
	       }
	       if ((line % 25) == 0)
		    twirlfn();
	  }
     }
     else {
	       
	  while ((numread = readn(sockfd, buf, sizeof buf)) > 0) {
	       if (fwrite(buf, numread, 1, f) == 0) {
		    CursesErrorMsg("Problems Writing");
		    closenet(sockfd);
		    return(FALSE);
	       }
	       twirlfn();
	  }
     }

     if (GSgetType(gs) == A_CSO)
	  writestring(sockfd, "quit\r\n");

     closenet(sockfd);
     return(TRUE);
}


/*
 * This function makes a nice vms filename.
 */

void
VMSfile(fname)
  char *fname;
{
#ifndef VMS
     return;
#else
     char *cp, *dot;
     int i, j;

     /**** Further tweek VMS names ****/

     /*** Replace illegal characters with dashes ***/
     for (cp = fname; *cp != '\0'; cp++) {
	  switch (*cp) {
	  case ':':
	  case ',':
	  case '\'':
	  case '\"':
	  case '/':
	  case ' ':
	       *cp = '-';
	  }
     }
	       
     /** Replace all but last dot with _'s, or **/
     /** second to last if last char is Z or z **/
     /** e.g., converts foo.tar.Z to foo.tar_Z **/

     dot = fname;
     j = strlen(fname) - 1;
     if ( (dot =strrchr(dot, '.')) != 0) {
	  if (((fname[j] != '.') &&
	       (*(dot+1) == 'Z' || *(dot+1) == 'z')) &&
	      (((cp =strchr(fname, '.')) != NULL) && cp < dot)) {
	       *dot = '_';
	       dot = strrchr(fname, '.');
	  }
	  cp = fname;
	  while ((cp =strchr(cp, '.')) != NULL && cp < dot) {
	       *cp = '_';
	  }
     }

     /** If the filename is longer than 39 characters, truncate,
         keep the extension though.. **/

     if ((j=strlen(fname)) > 37) {
	  fname[39] = '\0';
     }


     /** If there isn't an extension, add a '.', assume we have some space to
      *$^%& around with   **/
     
     if (strrchr(fname, '.') == NULL) {
	  cp = fname +strlen(fname);
	  
	  *cp = '.';
	  *(cp+1) = '\0';
     }

	  
#endif
}
     


/*
 * This function makes a nice UNIX filename
 */

void
UNIXfile(fname)
  char *fname;
{
     char *cp;

     for (cp = fname; *cp != '\0'; cp++) {
	  switch (*cp) {
	  case '\'':
	  case '\"':
	  case '/':
	  case ' ':
	       *cp = '-';
	  }
     }

     if (strlen(fname) >50) {
	  fname[40] = '\0';
     }
}


/*
 * This procedure prompts the user for a name, checks for pipe characters
 * and ~ characters in the filename and saves the file to disk.
 * 
 * If infile is NULL then contact the server and get the file.
 * 
 * If saveto is non-NULL then don't prompt the user for a filename
 * to save into, just "do it".
 */

void
Save_file(gs, saveto)
  GopherObj *gs;
  char *saveto;
{
     char    Userfilename[128];
     char    *cp, *view;
     int     sockfd;
     char    buf[1024];
     boolean Openpipe = FALSE;
     FILE    *f;
     char    *infile = GSgetLocalFile(gs);


     switch (GSgetType(gs)) {
     case A_DIRECTORY:
     case A_INDEX:
	  if (saveto == NULL)
	       return;
     }

     /*** Construct a nice default filename ***/
     
     if (saveto == NULL) {
	  /*** Let them use the Title ***/
	  strcpy(Userfilename, GSgetTitle(gs));

#ifdef VMS
	  VMSfile(Userfilename);
#else
	  UNIXfile(Userfilename);
#endif

	  if (CURGetOneOption(CursesScreen, "Save in file: ", Userfilename)<0)
	       return;

	  saveto = Userfilename;
     }

     if (*saveto == '\0')
	  return;

#ifndef VMS
     if (*saveto == '|') {
	  /** Open a pipe! **/
	  Openpipe = TRUE;
	  saveto++;
     }
     
     if (*saveto == '~') {
	  /*** Save in our home directory ***/
	  if (*(saveto + 1) == '/' && (cp = getenv("HOME")) != NULL) {
	       /*** Expand ~ to the home directory ***/
	       strcpy(buf,cp);
	       buf[strlen(cp)]='/';
	       strcpy(buf+strlen(cp) +1, saveto+2);
	       strcpy(saveto, buf);
	  } else {
	  /*** Save in someone else's home directory ***/
	       struct passwd *pass;

	       cp = strchr(saveto,'/');
	       *cp = '\0';
	       pass = getpwnam(saveto+1);
	       if (pass != NULL) {
		    /** align in prep for the home dir **/
		    strcpy(buf,pass->pw_dir);
		    buf[strlen(pass->pw_dir)]='/';
		    strcpy(buf+strlen(pass->pw_dir)+1,cp+1);
		    strcpy(saveto,buf);
		    
	       } else {
		    char tmpstr[256];
		    sprintf(tmpstr, "No such user '%s'", saveto+1);
		    CursesErrorMsg(tmpstr);
		    return;
	       }
	  }
     }
#endif

     if (Openpipe)
	  f = popen(saveto, "w+");
     else
	  f = fopen(saveto, "w+");

     if (f == NULL) {
	  char tempstr[128];

	  sprintf(tempstr, "Couldn't create '%s'", saveto);
	  CursesErrorMsg(tempstr);
	  return;
     }
     
     if (infile != NULL) {
	  /** We've already retrieved it, copy it over... **/
	  int oldfd, cc;

	  oldfd = open(infile, O_RDONLY);
	  if (oldfd <0) {
	       CursesErrorMsg("Can't open old file..");
	       if (Openpipe)
		    pclose(f);
	       else
		    fclose(f);
	       return;
	  }
	  
	  while ( (cc=read(oldfd, buf, sizeof buf)) > 0) {
	       if (fwrite(buf, cc, 1, f) <= 0)
		    CursesErrorMsg("Problems Writing");
	       twirl();
	  }
	  if (Openpipe)
	       pclose(f);
	  else
	       fclose(f);

	 close(oldfd);
	 return;

     } else {
	  /** We don't have the file yet, let's get it... **/
	  view = Choose_View(gs);
	  
	  if (view == NULL)
	       return;
	  
	  GStoFile(gs, f, view, NULL, twirl);
	  if (Openpipe)
	       pclose(f);
	  else
	       fclose(f);
     }
}



/*
** This procedure exits out of the curses environment and
** displays the file indicated by pathname to the screen
** using a pager command of some sort 
*/

void
GSdisplay(gs, view)
  GopherObj *gs;
  char      *view;
{
     static char command[MAXSTR];
     static char SaveName[MAXSTR];
     int ch;
     int c;
     char *file = GSgetLocalFile(gs);

     /** Search for a helper application **/
     RCdisplayCommand(GlobalRC, view, file, command);

     if (strlen(command) == 0) {
	  Save_file(gs, NULL);
	  return;
     }

     CURexit(CursesScreen);

     if (strcmp(command, "builtin") != 0)
	  system(command);
     else
	  Ourpager(GSgetLocalFile(gs));

#ifndef REMOTEUSER
/*Decent pagers give a prompt at the end, dont repeat the behaviour here
  and also handle mailing and printing for the remote user (Mitra)*/

     printf("\nPress <RETURN> to continue");

     if (!SecureMode && !NoShellMode)
	  printf(", <m> to mail, <s> to save, or <p> to print:");
#ifndef NOMAIL
     else
	  printf(", <m> to mail:");
#endif

     fflush(stdin);
     fflush(stdout);
     noecho();
     cbreak();

     ch = 0;
     while (ch == 0) {
	  ch=getchar();

	  if (SecureMode || NoShellMode) {
	       switch (ch) {
	       case '\n':
	       case '\r':
	       case KEY_ENTER:
	       case ' ':
		    break;
#ifndef NOMAIL
	       case 'm':
#ifdef VMS
                    (void) getchar();
#endif
		    CURenter(CursesScreen);
		    mail_file(GSgetLocalFile(gs), GSgetTitle(gs));
		    break;
#endif
	       default:
		    puts(CURgetBell(CursesScreen));
		    fflush(stdout);
		    ch=0;
		    break;
	       }
	  }
	  else {

	       switch(ch) {
	       case '\n':
	       case '\r':
	       case ' ' :
		    break;
	       case 's':
#ifdef VMS
                    (void) getchar();
#endif
		    CURenter(CursesScreen);
		    Draw_Status("Saving File...");
		    refresh();

		    Save_file(gs,NULL);
		    break;

	       case 'p':
#ifdef VMS
                    (void) getchar();
#endif
		    if (!RCprintCommand(GlobalRC, view, GSgetLocalFile(gs), command)) {
			 CursesErrorMsg("Sorry, cannot print this document");
			 return;
		    }
		    system(command);
		    break;
		    
	       case 'm':
#ifdef VMS
                    (void) getchar();
#endif
                    CURenter(CursesScreen);
		    mail_file(GSgetLocalFile(gs), GSgetTitle(gs));
		    break;
		    
	       default:
		    puts(CURgetBell(CursesScreen));
		    fflush(stdout);
		    ch=0;
		    break;
	       }
	  }
     }
     
#endif /*REMOTEUSER*/
     
     tputs(CURgetCLS(CursesScreen),1,outchar);
     fflush(stdout);
}


/*
** This mini pager is intended for people worried about shell escapes from
** more or less or whatever
*/


/*Ourpager(filename)
  char *filename;
{
     FILE *InFile;
     int i;
     char inputline[512], *cp;
     int Done = FALSE;
     char ZeTypedChar;
     
     if ((InFile = fopen(filename, "r")) == NULL)
	  return;

     while (Done == FALSE) {
	  tputs(CURgetCLS(CursesScreen),1,outchar);

	  for (i=0 ; i < LINES-1; i++) {
	       cp = fgets(inputline, 512, InFile);
	       ZapCRLF(inputline);
	       puts(inputline);
	  }

	  printf("----Press <ENTER> for next page, q to exit------");
	  
	  cbreak();
	  ZeTypedChar = getchar();
	  
	  if ((ZeTypedChar == 'q') || (cp == NULL)) {
	       printf("\n");
	       Done = TRUE;
	  }
     }

     cbreak();
     fclose(InFile);
}
*/



/*
 * This allows the user to add or change data in a form.
 *
 * It returns true if the user wants to keep the changes
 * It returns false if the user wants to abort
 *
 */

BOOLEAN
NewForm(ZeForm)
  Form *ZeForm;
{
     static char printstring[WHOLELINE];
     int         i;          /** Acme Buggy whips and integers **/
     char        ch;

     while (1) {

	  DisplayForm(ZeForm);

	  sprintf(printstring, "Press <ESC> to accept fields and continue");

	  CURcenterline(CursesScreen,"Press <ESC> to accept fields and continue", LINES-3);
	  CURcenterline(CursesScreen,"or press <CTRL-A> to abort", LINES-2);

	  refresh();

	  /*** Now get some user input ***/

	  for (i=0; i< ZeForm->numfields; i++) {

	       move(ZeForm->yloc[i],ZeForm->xloc[i] + strlen(ZeForm->tags[i])+2);
	       refresh();
	       echo();

	       ch = CURwgetstr(CursesScreen, stdscr, ZeForm->values[i],80);

	       /*** ESC key ***/
	       if (ch == '\033') {
		    noecho();
		    return(TRUE);
	       }

	       /*** CTRL-A ***/
	       else if (ch == '\001') {
		    noecho();
		    return(FALSE);
	       }

	       noecho();
	  }
	  
     }

}




/*
 * This Displays a form and a "menu".  It displays the Form
 * and then it waits for a keypress.  It returns the value of the
 * key that is pressed.
 */

void
DisplayForm(ZeForm)
  Form *ZeForm;
{
     int         availlines;
     int         optionlen;
     int         i;          /** Acme Buggy whips and integers **/


     clear();
     Draw_Banner();
     CURcenterline(CursesScreen, ZeForm->Title, 2);
     
     availlines = LINES - 6;
     
     /*** Print out the options according to the Form structure ***/
     
     for (i=0; i<ZeForm->numfields; i++) {
	  optionlen = strlen((ZeForm->tags)[i]);
	  mvaddstr(ZeForm->yloc[i],ZeForm->xloc[i], 
		   ZeForm->tags[i]);
	  addch(':');
	  addch(' ');
	  
	  /*** Now add the current value ***/
	  addstr((ZeForm->values)[i]);
     }
     
}

/*
 * This displays a single line message using CUR routines
 */
     
void
CursesMsg(Message, title)
  char *Message;
  char *title;
{
     char *mess[2];
     
     mess[0] = Message;
     mess[1] = NULL;

     CURBeep(CursesScreen);

     CURDialog(CursesScreen, title,mess);

     return;

}


/*
 * This does the same as above, but puts a window title on the mess 
 */

void
CursesErrorMsg(Message)
  char *Message;
{
     CursesMsg(Message, "Gopher Error");
}




